Attribute VB_Name = "modLookUp"
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit

'see http://www.iana.org/assignments/protocol-numbers
'current as of 18 October 2004
Public Function lookupIPprotocol(ByVal IPprotocol As Long) As String
  Dim shortLabel As String

  Select Case IPprotocol
  
    Case 0
      shortLabel = "HOPOPT" ' IPv6 Hop-by-Hop Option
    Case 1
      shortLabel = "ICMP" '  Internet Control Message
    Case 2
      shortLabel = "IGMP" '  Internet Group Management
    Case 3
      shortLabel = "GGP" ' Gateway-to-Gateway
    Case 4
      shortLabel = "IP" ' IP in IP (encapsulation)
    Case 5
      shortLabel = "ST" ' Stream
    Case 6
      shortLabel = "TCP" ' Transmission Control
    Case 7
      shortLabel = "CBT" ' CBT
    Case 8
      shortLabel = "EGP" ' Exterior Gateway Protocol
    Case 9
      shortLabel = "IGP" ' any private interior gateway
    Case 10
      shortLabel = "BBN-RCC-MON" ' BBN RCC Monitoring
    Case 11
      shortLabel = "NVP-II" '  Network Voice Protocol
    Case 12
      shortLabel = "PUP" ' PUP
    Case 13
      shortLabel = "ARGUS" ' ARGUS
    Case 14
      shortLabel = "EMCON" ' EMCON
    Case 15
      shortLabel = "XNET" '  Cross Net Debugger
    Case 16
      shortLabel = "Chaos" ' Chaos
    Case 17
      shortLabel = "UDP" ' User Datagram
    Case 18
      shortLabel = "MUX" ' Multiplexing
    Case 19
      shortLabel = "DCN-MEAS" '  DCN Measurement Subsystems
    Case 20
      shortLabel = "HMP" ' Host Monitoring
    Case 21
      shortLabel = "PRM" ' Packet Radio Measurement
    Case 22
      shortLabel = "XNS-IDP" ' XEROX NS IDP
    Case 23
      shortLabel = "TRUNK-1" ' Trunk-1
    Case 24
      shortLabel = "TRUNK-2" ' Trunk-2
    Case 25
      shortLabel = "LEAF-1" '  Leaf-1
    Case 26
      shortLabel = "LEAF-2" '  Leaf-2
    Case 27
      shortLabel = "RDP" ' Reliable Data Protocol
    Case 28
      shortLabel = "IRTP" '  Internet Reliable Transaction
    Case 29
      shortLabel = "ISO-TP4" ' ISO Transport Protocol Class
    Case 30
      shortLabel = "NETBLT" '  Bulk Data Transfer Protocol
    Case 31
      shortLabel = "MFE-NSP" ' MFE Network Services Protocol
    Case 32
      shortLabel = "MERIT-INP" ' MERIT Internodal Protocol
    Case 33
      shortLabel = "SEP" ' Sequential Exchange Protocol
    Case 34
      shortLabel = "3PC" ' Third Party Connect Protocol
    Case 35
      shortLabel = "IDPR" '  Inter-Domain Policy Routing Protocol
    Case 36
      shortLabel = "XTP" ' XTP
    Case 37
      shortLabel = "DDP" ' Datagram Delivery Protocol
    Case 38
      shortLabel = "IDPR-CMTP" ' IDPR Control Message Transport Protocol
    Case 39
      shortLabel = "TP++" '  TP++ Transport Protocol
    Case 40
      shortLabel = "IL" '  IL Transport Protocol
    Case 41
      shortLabel = "IPv6" ' IPv6
    Case 42
      shortLabel = "SDRP" '  Source Demand Routing Protocol
    Case 43
      shortLabel = "IPv6-Route" '  Routing Header for IPv6
    Case 44
      shortLabel = "IPv6-Frag" ' Fragment Header for IPv6
    Case 45
      shortLabel = "IDRP" '  Inter-Domain Routing Protocol
    Case 46
      shortLabel = "RSVP" '  Reservation Protocol
    Case 47
      shortLabel = "GRE" ' General Routing Encapsulation
    Case 48
      shortLabel = "MHRP" '  Mobile Host Routing Protocol
    Case 49
      shortLabel = "BNA" ' BNA
    Case 50
      shortLabel = "ESP" ' Encap Security Payload
    Case 51
      shortLabel = "AH" '  Authentication Header
    Case 52
      shortLabel = "I-NLSP" '  Integrated Net Layer Security
    Case 53
      shortLabel = "SWIPE" ' IP with Encryption
    Case 54
      shortLabel = "NARP" '  NBMA Address Resolution Protocol
    Case 55
      shortLabel = "MOBILE" '  IP Mobility
    Case 56
      shortLabel = "TLSP" '  Transport Layer Security Protocol
    Case 57
      shortLabel = "Skip" ' Skip
    Case 58
      shortLabel = "IPv6-ICMP" ' ICMP for IPv6
    Case 59
      shortLabel = "IPv6-NoNxt" '  No Next Header for IPv6
    Case 60
      shortLabel = "IPv6-Opts" ' Destination Options for IPv6
    Case 61
      shortLabel = "Host Internal" ' any host internal protocol
    Case 62
      shortLabel = "CFTP" ' CFTP
    Case 63
      shortLabel = "Any Local" ' any local network
    Case 64
      shortLabel = "SAT-EXPAK" ' SATNET and Backroom EXPAK
    Case 65
      shortLabel = "Kryptolan" ' Kryptolan
    Case 66
      shortLabel = "RVD" ' MIT Remote Virtual Disk Protocol
    Case 67
      shortLabel = "IPPC" '  Internet Pluribus Packet Core
    Case 68
      shortLabel = "Any Distributed" ' any distributed file system
    Case 69
      shortLabel = "SAT-MON" ' SATNET Monitoring
    Case 70
      shortLabel = "VISA" '  VISA Protocol
    Case 71
      shortLabel = "IPCV" '  Internet Packet Core Utility
    Case 72
      shortLabel = "CPNX" '  Computer Protocol Network Executive
    Case 73
      shortLabel = "CPHB" '  Computer Protocol Heart Beat
    Case 74
      shortLabel = "WSN" ' Wang Span Network
    Case 75
      shortLabel = "PVP" ' Packet Video Protocol
    Case 76
      shortLabel = "BR-SAT-MON" '  Backroom SATNET Monitoring
    Case 77
      shortLabel = "SUN-ND" '  SUN ND PROTOCOL-Temporary
    Case 78
      shortLabel = "WB-MON" '  WIDEBAND Monitoring
    Case 79
      shortLabel = "WB-EXPAK" '  WIDEBAND EXPAK
    Case 80
      shortLabel = "ISO-IP" '  ISO Internet Protocol
    Case 81
      shortLabel = "VMTP" ' VMTP
    Case 82
      shortLabel = "SECURE-VMTP" ' SECURE-VMTP
    Case 83
      shortLabel = "VINES" ' VINES
    Case 84
      shortLabel = "TTP" ' TTP
    Case 85
      shortLabel = "NSFNET-IGP" '  NSFNET-IGP
    Case 86
      shortLabel = "DGP" ' Dissimilar Gateway Protocol
    Case 87
      shortLabel = "TCF" ' TCF
    Case 88
      shortLabel = "EIGRP" ' EIGRP
    Case 89
      shortLabel = "OSPFIGP" ' OSPFIGP
    Case 90
      shortLabel = "Sprite-RPC" '  Sprite RPC Protocol
    Case 91
      shortLabel = "LARP" '  Locus Address Resolution Protocol
    Case 92
      shortLabel = "MTP" ' Multicast Transport Protocol
    Case 93
      shortLabel = "AX.25" ' AX.25 Frames
    Case 94
      shortLabel = "IPIP" '  IP-within-IP Encapsulation Protocol
    Case 95
      shortLabel = "MICP" '  Mobile Internetworking Control Protocol
    Case 96
      shortLabel = "SCC-SP" '  Semaphore Communications Sec Pro
    Case 97
      shortLabel = "ETHERIP" ' Ethernet-within-IP Encapsulation
    Case 98
      shortLabel = "ENCAP" ' Encapsulation Header
    Case 99
      shortLabel = "Private Encrypt" ' any private encryption scheme
    Case 100
      shortLabel = "GMTP" ' GMTP
    Case 101
      shortLabel = "IFMP" '  Ipsilon Flow Management Protocol
    Case 102
      shortLabel = "PNNI" '  PNNI over IP
    Case 103
      shortLabel = "PIM" ' Protocol Independent Multicast
    Case 104
      shortLabel = "ARIS" ' ARIS
    Case 105
      shortLabel = "SCPS" ' SCPS
    Case 106
      shortLabel = "QNX" ' QNX
    Case 107
      shortLabel = "A/N" ' Active Networks
    Case 108
      shortLabel = "IPComp" '  IP Payload Compression Protocol
    Case 109
      shortLabel = "SNP" ' Sitara Networks Protocol
    Case 110
      shortLabel = "Compaq-Peer" ' Compaq Peer Protocol
    Case 111
      shortLabel = "IPX-in-IP" ' IPX in IP
    Case 112
      shortLabel = "VRRP" '  Virtual Router Redundancy Protocol
    Case 113
      shortLabel = "PGM" ' PGM Reliable Transport Protocol
    Case 114
      shortLabel = "0-hop" ' any 0-hop protocol
    Case 115
      shortLabel = "L2TP" '  Layer Two Tunneling Protocol
    Case 116
      shortLabel = "DDX" ' D-II Data Exchange (DDX)
    Case 117
      shortLabel = "IATP" '  Interactive Agent Transfer Protocol
    Case 118
      shortLabel = "STP" ' Schedule Transfer Protocol
    Case 119
      shortLabel = "SRP" ' SpectraLink Radio Protocol
    Case 120
      shortLabel = "UTI" ' UTI
    Case 121
      shortLabel = "SMP" ' Simple Message Protocol
    Case 122
      shortLabel = "SM" ' SM
    Case 123
      shortLabel = "PTP" ' Performance Transparency Protocol
    Case 124
      shortLabel = "ISIS over IPv4" '  ISIS over IPv4
    Case 125
      shortLabel = "FIRE" ' FIRE
    Case 126
      shortLabel = "CRTP" '  Combat Radio Transport Protocol
    Case 127
      shortLabel = "CRUDP" ' Combat Radio User Datagram
    Case 128
      shortLabel = "SSCOPMCE" ' SSCOPMCE
    Case 129
      shortLabel = "IPLT" ' IPLT
    Case 130
      shortLabel = "SPS" ' Secure Packet Shield
    Case 131
      shortLabel = "PIPE" '  Private IP Encapsulation within IP
    Case 132
      shortLabel = "SCTP" '  Stream Control Transmission Protocol
    Case 133
      shortLabel = "FC" '  Fibre Channel
    Case 134
      shortLabel = "RSVP-E2E-IGNORE" ' RSVP-E2E-IGNORE
    Case 135
      shortLabel = "Mobility Header" ' Mobility Header
    Case 136
      shortLabel = "UDPLite" ' UDPLite
    Case 137
      shortLabel = "MPLS-in-IP" '  MPLS-in-IP
    Case 138 To 252
      shortLabel = "Unassigned" ' Unassigned
    Case 253 To 254
      shortLabel = "Experimental" ' Used for experimentation and testing
    Case 255
      shortLabel = "Reserved" ' Reserved
End Select
    lookupIPprotocol = shortLabel
End Function
